/*
 * Copyright (c) 2007 innoSysTec (R) GmbH, Germany. All rights reserved.
 * Original author: Edmund Wagner
 * Creation date: 23.05.2007
 *
 * Source: $HeadURL$
 * Last changed: $LastChangedDate$
 * 
 * the unrar licence applies to all junrar source and binary distributions 
 * you are not allowed to use this source to re-create the RAR compression algorithm
 * 
 * Here some html entities which can be used for escaping javadoc tags:
 * "&":  "&#038;" or "&amp;"
 * "<":  "&#060;" or "&lt;"
 * ">":  "&#062;" or "&gt;"
 * "@":  "&#064;" 
 */
package de.innosystec.unrar.io;


/**
 * DOCUMENT ME
 *
 * @author $LastChangedBy$
 * @version $LastChangedRevision$
 */
public interface IReadOnlyAccess {
	/**
	 * @param buffer where to store the read data
	 * @param count how many bytes to read
	 * @return bytes read || -1 if  IO problem 
	 */
	public int readBytes(byte[] buffer, int count);
	
	
	/**
	 * @return the current position in the file
	 */
	public long getPosition();
		
	/**
	 * @param pos the position in the file
	 * @return success ? true : false 
	 */
	public boolean setPosition(long pos);
}
