/*
 * Copyright (c) 2007 innoSysTec (R) GmbH, Germany. All rights reserved.
 * Original author: Edmund Wagner
 * Creation date: 23.05.2007
 *
 * Source: $HeadURL$
 * Last changed: $LastChangedDate$
 * 
 * the unrar licence applies to all junrar source and binary distributions 
 * you are not allowed to use this source to re-create the RAR compression algorithm
 * 
 * Here some html entities which can be used for escaping javadoc tags:
 * "&":  "&#038;" or "&amp;"
 * "<":  "&#060;" or "&lt;"
 * ">":  "&#062;" or "&gt;"
 * "@":  "&#064;" 
 */
package de.innosystec.unrar.io;

import java.io.EOFException;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.RandomAccessFile;

/**
 * DOCUMENT ME
 *
 * @author $LastChangedBy$
 * @version $LastChangedRevision$
 */
public class ReadOnlyAccessFile extends RandomAccessFile implements IReadOnlyAccess{

	/**
	 * @param file the file
	 * @throws FileNotFoundException
	 */
	public ReadOnlyAccessFile(File file) throws FileNotFoundException {
		super(file, "r");
	}

	public long getPosition() {
		try {
			return this.getFilePointer();
		} catch (IOException e) {
			return -1;
		}
	}

	public int readBytes(byte[] buffer, int count) {
		int read = 0;
		try {
			for (int i = 0; i < count; i++) {
				buffer[i] = this.readByte();
				read++;
			}
			return read;
		} catch (EOFException e){
			return read;
		} catch (IOException ee) {
			return -1;
		}
	}

	public boolean setPosition(long pos) {
		try {
			this.seek(pos);
			return true;
		} catch (IOException e) {
			return false;
		}
	}
	
}
