/*
 * Copyright (c) 2007 innoSysTec (R) GmbH, Germany. All rights reserved.
 * Original author: Edmund Wagner
 * Creation date: 24.05.2007
 *
 * Source: $HeadURL$
 * Last changed: $LastChangedDate$
 * 
 * the unrar licence applies to all junrar source and binary distributions 
 * you are not allowed to use this source to re-create the RAR compression algorithm
 * 
 * Here some html entities which can be used for escaping javadoc tags:
 * "&":  "&#038;" or "&amp;"
 * "<":  "&#060;" or "&lt;"
 * ">":  "&#062;" or "&gt;"
 * "@":  "&#064;" 
 */
package de.innosystec.unrar.rarfile;

import de.innosystec.unrar.io.Raw;

/**
 * DOCUMENT ME
 *
 * @author $LastChangedBy$
 * @version $LastChangedRevision$
 */
public class AVHeader extends BaseBlock {
	
	public static final int avHeaderSize = 7;
	
	private byte unpackVersion;
	private byte method;
	private byte avVersion;
	private int avInfoCRC;
	
	private byte[] avHeader = new byte[avHeaderSize];
	
	
	public AVHeader(BaseBlock bb, byte[] avHeader){
		super(bb);
		
		this.avHeader = avHeader;
		
		int pos =0;
		unpackVersion |= avHeader[pos]&0xff;
		pos++;
		method |= avHeader[pos]&0xff;
		pos++;
		avVersion |= avHeader[pos]&0xff;
		pos++;
		avInfoCRC = Raw.readIntLittleEndian(avHeader, pos);
	}
	
	public int getAvInfoCRC() {
		return avInfoCRC;
	}
	public void setAvInfoCRC(int avInfoCRC) {
		this.avInfoCRC = avInfoCRC;
	}
	public byte getAvVersion() {
		return avVersion;
	}
	public void setAvVersion(byte avVersion) {
		this.avVersion = avVersion;
	}
	public byte getMethod() {
		return method;
	}
	public void setMethod(byte method) {
		this.method = method;
	}
	public byte getUnpackVersion() {
		return unpackVersion;
	}
	public void setUnpackVersion(byte unpackVersion) {
		this.unpackVersion = unpackVersion;
	}
	
	
	
	
}
